Imports Telerik.Web.UI
Imports System.IO

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        RadEditor1.ImageManager.ViewPaths = New String() {"~/Images"}
        RadEditor1.ImageManager.UploadPaths = New String() {"~/Images"}
        RadEditor1.ImageManager.DeletePaths = New String() {"~/Images"}
        RadEditor1.ImageManager.MaxUploadFileSize = 10000000
        RadEditor1.ImageManager.ContentProviderTypeName = GetType(DialogWthRegexValidator).AssemblyQualifiedName
    End Sub
    Public Class DialogWthRegexValidator
        Inherits Telerik.Web.UI.Widgets.FileSystemContentProvider
#Region "Customization"
        Const _strRegex As String = "^[a-z0-9_=]+$" 'it accepts only: lowercase, numbers,"_" , "="
        Const _strChaneForInvalidChar As String = "_"
        Const _blnConsiderOverWriteFilesChangingName As Boolean = True

        Const _TypeAdvise As TypeBlock = TypeBlock.Change
        Const _strAlertForRenameFile As String = "The name {0} can not be used because rename the file {1} for restrictation of rules web site"
        Const _strAlertForUploadFile As String = "The file {0} can not be upload because restrictation of rules web site"
        Const _strAlertForAlreadyExistingFile As String = "The file {0} can not be upload/renamed because changing his name with restrictation of rules web site the new file name ({1}) already exist inside the directory and you choose to do not overwrite existing files."

        Const _strAlertForRenameDir As String = "The name {0} can not be used for rename the dir {1} because restrictation of rules web site"
        Const _strAlertForCreateDir As String = "The name {0} can not be used for the directory because restrictation of rules web site"

        Private Function ReturnCorrectString(ByVal str As String) As String
            'Here you have to put the logic for changing the name in a way that meets the site rules
            str = str.ToLower
            Dim sb As New StringBuilder
            For Each c As Char In str
                If RegexTest(c) = True Then
                    sb.Append(c)
                Else
                    sb.Append(_strChaneForInvalidChar)
                End If
            Next
            Return sb.ToString
        End Function
#End Region
#Region "Private Function and Enums"
        Private Function RegexTest(ByVal str As String) As Boolean
            'Simple RegularExpression test
            Dim regEx As Regex = New Regex(_strRegex)
            Return regEx.IsMatch(str)
        End Function
        Private Function CreateAlert(ByRef strMessage As String) As String
            Dim script As String = String.Format("alert('{0}');", strMessage)
            ' Send the script to the browser
            ' 1. Find the page where the RadFileExplorer is declared.
            Dim _page As Page = TryCast(Me.Context.CurrentHandler, Page)
            ' 2. register the script:
            ScriptManager.RegisterStartupScript(_page, _page.[GetType](), "KEY", script, True)
            Return String.Empty
        End Function
        Private Enum TypeBlock
            Alert = 0
            Change = 1
        End Enum
#End Region
        Public Sub New(ByVal context As HttpContext, ByVal searchPatterns As String(), ByVal viewPaths As String(), ByVal uploadPaths As String(), ByVal deletePaths As String(), ByVal selectedUrl As String, _
         ByVal selectedItemTag As String)
            MyBase.New(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, _
             selectedItemTag)
        End Sub
        Public Overrides Function MoveDirectory(ByVal path As String, ByVal newPath As String) As String
            'Take only the name of the new Dir
            Dim strNewDir As String = newPath.Substring(newPath.LastIndexOf("/"))
            strNewDir = strNewDir.Replace("/", "")
            'Check that name
            If RegexTest(strNewDir) = True Then 'If ok >>> GO with default behaviour
                Return MyBase.MoveDirectory(path, newPath)
            Else 'If no check what the developer want
                Select Case _TypeAdvise
                    Case TypeBlock.Alert
                        'Make a alert
                        Return CreateAlert(String.Format(_strAlertForRenameDir, strNewDir, path.Substring(path.LastIndexOf("/")).Replace("/", "")))
                    Case TypeBlock.Change
                        'Change the name and store
                        'Changing the name that meets the rule
                        strNewDir = ReturnCorrectString(strNewDir)
                        'Take the previous path
                        Dim strDirBefore As String = newPath.Substring(0, newPath.LastIndexOf("/"))
                        'Change the default parameter with the correct path
                        Return MyBase.MoveDirectory(path, String.Concat(strDirBefore, "/", strNewDir))
                    Case Else
                        'Put Just for JC advise :-)
                        Return String.Empty
                End Select
            End If
        End Function
        Public Overrides Function CreateDirectory(ByVal path As String, ByVal name As String) As String
            'Check that name
            If RegexTest(name) = True Then 'If ok >>> GO with default behaviour
                Return MyBase.CreateDirectory(path, name)
            Else 'If no check what the developer want
                Select Case _TypeAdvise
                    Case TypeBlock.Alert
                        'Make a alert
                        Return CreateAlert(String.Format(_strAlertForCreateDir, name))
                    Case TypeBlock.Change
                        'Change the default parameter with the correct name, we don't have to worry about existing dir because the component make itself this check even with a different directory's name
                        Return MyBase.CreateDirectory(path, ReturnCorrectString(name))
                    Case Else
                        'Put Just for JC advise :-)
                        Return String.Empty
                End Select
            End If
        End Function
        Public Overrides Function MoveFile(ByVal path As String, ByVal newPath As String) As String
            'Get The old Filename
            Dim strOldFile As String = path.Substring(path.LastIndexOf("/"))
            strOldFile = strOldFile.Replace("/", "")
            '.
            'Get the new Filename
            Dim strNewFile As String = newPath.Substring(newPath.LastIndexOf("/"))
            strNewFile = strNewFile.Replace("/", "")
            '.
            'Separate the name through the extension because the rules of the website perhaps could not pass the "." char and so is better to check only the name and also we have not to check the extension
            Dim strOldFileNameWithoutExtension As String = strNewFile.Substring(0, strNewFile.IndexOf("."))
            Dim strOldFileExtension As String = strNewFile.Substring(strNewFile.LastIndexOf("."))
            '.
            'Separate the name through the extension because the rules of the website perhaps could not pass the "." char and so is better to check only the name and also we have not to check the extension
            Dim strNewFileNameWithoutExtension As String = strNewFile.Substring(0, strNewFile.IndexOf("."))
            Dim strNewFileExtension As String = strNewFile.Substring(strNewFile.LastIndexOf("."))
            '.
            'Check the name
            If RegexTest(strNewFileNameWithoutExtension) = True Then 'If ok >>> GO with default behaviour
                Return MyBase.MoveFile(path, newPath)
            Else 'If no check what the developer want
                Select Case _TypeAdvise
                    Case TypeBlock.Alert
                        'Make a alert
                        Return CreateAlert(String.Format(_strAlertForRenameFile, String.Concat(strNewFileNameWithoutExtension, strNewFileExtension), String.Concat(strOldFileNameWithoutExtension, strOldFileExtension)))
                    Case TypeBlock.Change
                        'Change the default parameter with the correct name, we don't have to worry about existing files because the component make itself this check even with a different filename
                        strNewFileNameWithoutExtension = ReturnCorrectString(strNewFileNameWithoutExtension)
                        Dim strDirBefore As String = newPath.Substring(0, newPath.LastIndexOf("/"))
                        Return MyBase.MoveFile(path, String.Concat(strDirBefore, "/", strNewFileNameWithoutExtension, strNewFileExtension))
                    Case Else
                        Return String.Empty
                End Select
            End If
        End Function
        Public Overrides Function StoreFile(ByVal file__1 As UploadedFile, ByVal path__2 As String, ByVal name As String, ByVal ParamArray arguments As String()) As String
            'Separate the name through the extension because the rules of the website perhaps could not pass the "." char and so is better to check only the name
            Dim strFileNameWithoutExtension As String = name.Substring(0, name.IndexOf("."))
            Dim strFileExtension As String = name.Substring(name.LastIndexOf("."))
            '.
            'Check the name
            If RegexTest(strFileNameWithoutExtension) = True Then 'If ok >>> GO with default behaviour
                Dim result As String = MyBase.StoreFile(file__1, path__2, name, arguments)
                Return result
            Else 'If no check what the developer want
                Select Case _TypeAdvise
                    Case TypeBlock.Alert
                        'Make a alert
                        Return CreateAlert(String.Format(_strAlertForUploadFile, String.Concat(strFileNameWithoutExtension, strFileExtension)))
                    Case TypeBlock.Change
                        'Transform the name changing meets the rules
                        Dim newFileName As String = ReturnCorrectString(strFileNameWithoutExtension)
                        If _blnConsiderOverWriteFilesChangingName = False Then 'if the developer doesn't care about overwriting files go!
                            Return MyBase.StoreFile(file__1, path__2, newFileName, arguments)
                        Else
                            'Check if the files uploaded already exist or not
                            ' Build the path to the file in order to check whether the file already exists:
                            Dim virtualPathToTheNewFile As String = Path.Combine(path__2, String.Concat(newFileName, strFileExtension))
                            ' Convert the virtual path to a physical path (File.Exists works with physical paths)  
                            Dim physicalPathToFile As String = Me.Context.Server.MapPath(virtualPathToTheNewFile)
                            ' Check whether the file exists, before calling the base.StoreFile:
                            If File.Exists(physicalPathToFile) Then
                                ' File exists ==> Check what the user choose:
                                Dim _page As Page = DirectCast(Me.Context.CurrentHandler, Page)
                                ' Find the RadFileExplorer control
                                Dim fileExplorer1 As RadFileExplorer = DirectCast(_page.FindControl("RadFileExplorer1"), RadFileExplorer)
                                ' Find the 'chkOverwrite' checkbox
                                Dim checkBox As CheckBox = DirectCast(fileExplorer1.FindControl("chkOverwrite"), CheckBox)
                                If (checkBox.Checked) Then
                                    'The user accept to overwrite always the files if he upload a files that doesn't meet the rules he is dummy so...overwrite it!
                                    Return MyBase.StoreFile(file__1, path__2, newFileName, arguments)
                                Else
                                    'Make an alert
                                    Return CreateAlert(String.Format(_strAlertForAlreadyExistingFile, String.Concat(strFileNameWithoutExtension, strFileExtension), String.Concat(newFileName, strFileExtension)))
                                End If
                            Else
                                ' File does not exist then store the file:
                                Return MyBase.StoreFile(file__1, path__2, String.Concat(newFileName, strFileExtension), arguments)
                            End If

                        End If
                    Case Else
                        Return String.Empty
                End Select
            End If
        End Function
    End Class
End Class
